-- Lua script made by Rapidgame7

-- Firerate seems to be incompatible. At least for a while!
-- Removed variable initializers. Learned a lesson: Do not initialize a variable here if you plan into using it on multiplayer!



-- Time to create the command!
COM_AddCommand("permguns", function(player, vauto, vbounce, vscatter, vgrenade, vexplode, vrail)
if vauto ~= nil then
server.permguns = 0
	-- Setting the guns to a variable.
	if vauto == '1' then
		server.permguns = $ + 1
	end
	if vbounce == '1' then
		server.permguns = $ + 2
	end
	if vscatter == '1' then
		server.permguns = $ + 4
	end
	if vgrenade == '1' then
		server.permguns = $ + 8
	end
	if vexplode == '1' then
		server.permguns = $ + 16
	end
	if vrail == '1' then
		server.permguns = $ + 32
	end
	-- Doing it again for another number!
	if vauto == '2' then
		server.permguns = $ + 1
	end
	if vbounce == '2' then
		server.permguns = $ + 2
	end
	if vscatter == '2' then
		server.permguns = $ + 4
	end
	if vgrenade == '2' then
		server.permguns = $ + 8
	end
	if vexplode == '2' then
		server.permguns = $ + 16
	end
	if vrail == '2' then
		server.permguns = $ + 32
	end
	
	-- God what a mess. I could have used OR but this looks easier.
	-- Now, time to set some other vars.
	if vbounce == nil then vbounce = '0' end
	if vscatter == nil then vscatter = '0' end
	if vgrenade == nil then vgrenade = '0' end
	if vexplode == nil then vexplode = '0' end
	if vrail == nil then vrail = '0' end
	
	server.ggauto = tonumber(vauto)
	server.ggbounce = tonumber(vbounce)
	server.ggscatter = tonumber(vscatter)
	server.gggrenade = tonumber(vgrenade)
	server.ggexplode = tonumber(vexplode)
	server.ggrail = tonumber(vrail)
	
	print("\x82[PG]\x80 Permanent guns have been set by the server.")
	
	elseif vauto == nil then
	CONS_Printf(player, "\x82[PG]\x80 The arguments for this command:")
	CONS_Printf(player, "\x82[PG]\x80 auto bounce scatter grenade explosion rail")
	CONS_Printf(player, "\x82[PG]\x80 All you have to do is:")
	CONS_Printf(player, "\x82[PG]\x80 Put 0 for the gun you don't want to be picked up by the players.")
	CONS_Printf(player, "\x82[PG]\x80 Put 1 for the gun you want to make permanent. Doesn't use rings.")
	CONS_Printf(player, "\x82[PG]\x80 Put 2 for the gun you want to make permanent. This variation uses your rings, but the weapon ammo stays the same.")
	--CONS_Printf(player, "\x82[PG]\x80 Put 3 for the gun you want to work normally: Players can pick it up and use it normally, as in match. No infinite ammo for it.")
	-- I'm currently unable to do that.
	-- The guns are set every tic, there's no way I can tell the game to leave alone the guns whose argument is 3.
	-- If there were a variable in the game code, like "player.weapons[gun_automatic]" then I can.
	-- But no. There isn't any variable like that.
	CONS_Printf(player, "\x82[PG]\x80 If any of the arguments for the command isn't set, it will be automatically set to 0.")
	end
end, 1)

addHook("ThinkFrame", function()
	for player in players.iterate do
	
	-- Synchronizing the variables.
	-- If you are the server, then this will only set all variables to zero. Nothing else.
	-- If you are a client, then this will be set to zero THEN it will take the variables from the server.
	-- We won't use the clientside variables, don't worry.
	-- It's just to initialize this.
	if player.permguns == nil then
		player.permguns = 0
		player.permguns = server.permguns
	end
	
	if player.ggauto == nil then
		player.ggauto = 0
		player.ggbounce = 0
		player.ggscatter = 0
		player.gggrenade = 0
		player.ggexplode = 0
		player.ggrail = 0

		player.ggauto = server.ggauto
		player.ggbounce = server.ggbounce
		player.ggscatter = server.ggscatter
		player.gggrenade = server.gggrenade
		player.ggexplode = server.ggexplode
		player.ggrail = server.ggrail
	end
	-- Done. Haha!
	
-- Giving the panels chosen and removing the ones not chosen EVERY SINGLE TICK.
-- Well, at least that's what this is supposed to do!
player.ringweapons = server.permguns

-- If one of the weapons ammo reaches 998, it will be reset to 999.
-- (998 is the key number: Normally you can't reach that number outside the normal maps)
-- If set, we also give the player a ring.
if player.powers[pw_automaticring] == 998 then
	player.powers[pw_automaticring] = 999
	if server.ggauto == 1 then
	player.mo.health = $ + 1
	player.health = $ + 1
	end
end

if player.powers[pw_bouncering] == 998 then
	player.powers[pw_bouncering] = 999
	if server.ggbounce == 1 then
	player.mo.health = $ + 1
	player.health = $ + 1
	end
end

if player.powers[pw_scatterring] == 998 then
	player.powers[pw_scatterring] = 999
	if server.ggscatter == 1 then
	player.mo.health = $ + 1
	player.health = $ + 1
	end
end

if player.powers[pw_grenadering] == 998 then
	player.powers[pw_grenadering] = 999
	if server.gggrenade == 1 then
	player.mo.health = $ + 1
	player.health = $ + 1
	end
end

if player.powers[pw_explosionring] == 998 then
	player.powers[pw_explosionring] = 999
	if server.ggexplode == 1 then
	player.mo.health = $ + 1
	player.health = $ + 1
	end
end

if player.powers[pw_railring] == 998 then
	player.powers[pw_railring] = 999
	if server.ggrail == 1 then
	player.mo.health = $ + 1
	player.health = $ + 1
	end
end

-- Here, after all code has been ran:
-- If the argument for X gun is 0, then set its ammo to 0. It will be always 0 as this code is being ran in ThinkFrame, that is, every tic.
-- If the argument is 1, then set it's ammo to 999. The code to check if it's 998 is done before this, so the above always work.
-- If the argument is 2, do the same as 1. Rings aren't lost in 1 because of a code it gives a ring when the gun is used (it's ammo is 998). This one doesn't give a ring, so... No code.
-- If the argument is 3, no code for it as it should work normally. BUT AS STATED ABOVE THERE ISNT A VARIABLE FOR EVERY GUN SO EITHER A GUN IS ENABLED, ENABLED WITHOUT RING RESTORE OR DISABLED.
if (server.ggauto == 1) or (server.ggauto == 2) then
player.powers[pw_automaticring] = 999
elseif server.ggauto == 0 then
player.powers[pw_automaticring] = 0
end
if (server.ggbounce == 1) or (server.ggbounce == 2) then
player.powers[pw_bouncering] = 999
elseif server.ggbounce == 0 then
player.powers[pw_bouncering] = 0
end
if (server.ggscatter == 1) or (server.ggscatter == 2) then
player.powers[pw_scatterring] = 999
elseif server.ggscatter == 0 then
player.powers[pw_scatterring] = 0
end
if (server.gggrenade == 1) or (server.gggrenade == 2) then
player.powers[pw_grenadering] = 999
elseif server.gggrenade == 0 then
player.powers[pw_grenadering] = 0
end
if (server.ggexplode == 1) or (server.ggexplode == 2) then
player.powers[pw_explosionring] = 999
elseif server.ggexplode == 0 then
player.powers[pw_explosionring] = 0
end
if (server.ggrail == 1) or (server.ggrail == 2) then
player.powers[pw_railring] = 999
elseif server.ggrail == 0 then
player.powers[pw_railring] = 0
end


end
end)


